#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2800four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 2800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2800four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four28004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four28004xi = {
                1:'1007x-298y2595z',
                2:'1015x-968y2423z',
                3:'1022x-1498y2132z',
                4:'1033x-1924y1751z',
                5:'1047x-251y2584z',
                6:'1083x-929y2408z',
                7:'1084x-201y2573z',
                8:'1112x-1460y2114z',
                9:'1118x-147y2562z',
                10:'1122x-2522y465z',
                11:'1142x-1882y1729z',
                12:'1149x-886y2394z',
                13:'1150x-91y2551z',
                14:'1179x-31y2539z',
                15:'1200x-1415y2096z',
                16:'1213x-838y2379z',
                17:'1248x-1834y1707z',
                18:'1255x-2464y438z',
                19:'1276x-785y2365z',
                20:'1287x-1366y2077z',
                21:'1336x-729y2349z',
                22:'1353x-1779y1685z',
                23:'1372x-1311y2058z',
                24:'1384x-2398y410z',
                25:'1393x-668y2334z',
                26:'142x-2717y657z',
                27:'1448x-603y2319z',
                28:'1454x-1251y2039z',
                29:'1455x-1719y1663z',
                30:'1499x-534y2303z',
                31:'1510x-2326y382z',
                32:'1533x-1185y2020z',
                33:'1547x-462y2287z',
                34:'1554x-1652y1640z',
                35:'1591x-385y2270z',
                36:'1610x-1115y2000z',
                37:'1632x-2246y355z',
                38:'1632x-306y2254z',
                39:'1650x-1580y1617z',
                40:'1668x-223y2237z',
                41:'166x-127y2792z',
                42:'1683x-1039y1980z',
                43:'1699x-137y2220z',
                44:'1726x-49y2203z',
                45:'1743x-1502y1594z',
                46:'1750x-2161y327z',
                47:'1752x-959y1961z',
                48:'1818x-875y1941z',
                49:'1832x-1418y1571z',
                50:'1862x-2068y299z',
                51:'1879x-786y1920z',
                52:'189x-536y2741z',
                53:'1916x-1329y1548z',
                54:'1936x-693y1900z',
                55:'195x-134y2789z',
                56:'1970x-1970y271z',
                57:'1987x-596y1879z',
                58:'1996x-1235y1524z',
                59:'2034x-496y1858z',
                60:'2072x-1136y1501z',
                61:'2072x-1866y243z',
                62:'2075x-392y1837z',
                63:'2111x-285y1816z',
                64:'2141x-176y1795z',
                65:'2142x-1033y1477z',
                66:'2165x-64y1773z',
                67:'2169x-1756y215z',
                68:'2206x-925y1453z',
                69:'2260x-1642y188z',
                70:'226x-138y2787z',
                71:'228x-551y2735z',
                72:'2344x-1522y160z',
                73:'2346x-842y1480z',
                74:'2422x-1398y132z',
                75:'2493x-1270y104z',
                76:'2556x-1138y76z',
                77:'257x-139y2784z',
                78:'2613x-1003y48z',
                79:'2662x-865y20z',
                80:'268x-563y2729z',
                81:'285x-2713y630z',
                82:'289x-137y2781z',
                83:'310x-572y2723z',
                84:'322x-132y2778z',
                85:'354x-578y2716z',
                86:'355x-124y2774z',
                87:'387x-114y2770z',
                88:'399x-581y2709z',
                89:'420x-100y2766z',
                90:'427x-2700y603z',
                91:'445x-581y2702z',
                92:'451x-82y2762z',
                93:'458x-1114y2527z',
                94:'483x-62y2757z',
                95:'493x-578y2694z',
                96:'513x-39y2752z',
                97:'527x-1111y2515z',
                98:'541x-13y2747z',
                99:'541x-570y2687z',
                100:'569x-2680y576z',
                101:'589x-560y2679z',
                102:'596x-1104y2502z',
                103:'638x-546y2670z',
                104:'666x-1093y2490z',
                105:'687x-528y2662z',
                106:'710x-2652y548z',
                107:'736x-1077y2477z',
                108:'736x-506y2653z',
                109:'747x-1581y2186z',
                110:'784x-481y2644z',
                111:'807x-1056y2464z',
                112:'831x-451y2635z',
                113:'839x-1559y2168z',
                114:'850x-2616y521z',
                115:'877x-1031y2450z',
                116:'877x-419y2625z',
                117:'922x-382y2615z',
                118:'931x-1531y2150z',
                119:'946x-1002y2437z',
                120:'966x-342y2605z',
                121:'987x-2573y493z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2800four4xi" usage = "target function for charge28004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2800four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2800FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2800FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2800FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2800FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2800FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four28004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2800FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2800FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2800FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four28004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four28004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2800FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2800FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2800FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2800four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                    